#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_LargeFishCFG3.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_LargeFishCFG3> Fish_LargeFishCFG3::msSingleton(nullptr);

int Fish_LargeFishCFG3::GetCount()
{
	return (int)mMapData.size();
}

const Fish_LargeFishCFG3Data* Fish_LargeFishCFG3::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_LargeFishCFG3Data>& Fish_LargeFishCFG3::GetMapData()
{
	return mMapData;
}

void Fish_LargeFishCFG3::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_LargeFishCFG3::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_LargeFishCFG3Data data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mGeneratorID = element->IntAttribute("GeneratorID");
		data.mFishID = element->IntAttribute("FishID");
		data.mImageInfo = element->Attribute("ImageInfo");
		data.mIsBoss = element->BoolAttribute("IsBoss");
		data.mBackSound = element->Attribute("BackSound");
		data.mDuration = element->IntAttribute("Duration");
		data.mWarnTime = element->IntAttribute("WarnTime");
		data.mFlashTime = element->IntAttribute("FlashTime");
		data.mDieTime = element->IntAttribute("DieTime");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_LargeFishCFG3::Load()
{
	Load("../Config/Fish_LargeFishCFG3.xml");
}

Fish_LargeFishCFG3* Fish_LargeFishCFG3::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_LargeFishCFG3());
	}
	return msSingleton.get();
}
